**2019-09-06**

Some remarks to Ben.

You can now use widgets from different reactopya projects in the same parent
widget. That's a big deal. It's difficult because each project's bundle is built
off of a different global React object. There are various ways that people try
to handle this type of thing, but it's not easy. My philosophy is -- the
reactopya projects should contain minimal code, and the magic happens in the
background.

Code generation is key here. On the one hand, the projects should have minimal
code -- but on the other hand we don't want heavy dependencies. So with code
generation, almost all the functionality is in the package uploaded to pypi.

For example, it would allow us to maintain (if we wanted) the HBox, VBox,
Accordion stuff in a separate project. (We might not want to). But it also
allows breaking things up. Some widgets will be more generic than neurophys --
e.g., the 3D surface rendering.

In the case of HBox, VBox, I tend to think they can just be replicated in the
various projects. For example:

```
ephys_viz.HBox(....)
```

would be essentially the same as

```
ccm_widgets.HBox(...)
```

But they are so light that they can just be duplicated rather than requiring
additional dependencies.