## {{ project_name }} installation

This file was auto-generated by reactopya and all reactopya projects share these installation instructions.

## Prerequisites

* Linux or OS X
* Python >= 3.6

## Installing the Python package

Install the {{ project_name }} Python package:

```
# currently at version {{ project_name }}=={{ version }}
pip install --upgrade {{ project_name }}
```

Then, depending on how you intend to use the library, use one or more of the following methods.


## JupyterLab and Jupyter Notebook

To use {{ project_name }} within JupyterLab and in Jupyter Notebook you will first need to install the reactopya_jup notebook extension.

As a prerequisite (for JupyterLab) you need the ipywidgets lab extension:

```
jupyter labextension install @jupyter-widgets/jupyterlab-manager
```

Next, install the the latest reactopya_jup Python package:

```
pip install --upgrade reactopya_jup==0.7.3
```

For JupyterLab, install the lab extension:

```
jupyter labextension install reactopya_jup@0.7.3
```

For Jupyter Notebook, install and enable the notebook extension:

```
jupyter nbextension install --sys-prefix --py reactopya_jup
jupyter nbextension enable reactopya_jup --py --sys-prefix
```

Finally you should use the following at the top of your notebook:

```
import {{ project_name }}
{{ project_name }}.init_jupyter()
```

See the notebook_examples directory which might exist at the root of this repository.

## Desktop widgets (via electron)

To view the widgets as standalone desktop windows (outside of the notebook), you must first install electron. You will need NodeJS >= 8.

```
npm install -g electron
```

If you run into permissions problems, follow the instructions [here](https://github.com/sindresorhus/guides/blob/master/npm-global-without-sudo.md) to configure npm to install global packages inside your home directory.

Now you may write a .py script that begins with the following lines:

```
import {{ project_name }}
{{ project_name }}.init_electron()
```

or you can launch a widget from a .json file via:

```
{{ project_name }} show --widget [file.json]
```

See the desktop_examples directory which might exist at the root of this repository.

## Web server

To host a {{ project_name }} widget as a web server, simply create the widget in a Python script and then run:

```
widget.host(port=6065)
```

where 6065 may be replaced by any open port. Then you can view the widget in your browser by navigating to `http://localhost:6065`. There may be examples of this in the desktop_examples/ directory.

## Google colaboratory

No extensions are needed for colaboratory, but you do need to pip install reactopya_jup as above. Then the top of your notebook should include:

```
import {{ project_name }}
{{ project_name }}.init_colab()
```

While it is possible to use a local runtime for colab, this involves a bit of a hack to get the callbacks to work properly. Ask me about it if you are interested.


## Development installation

A development installation has the following additional prerequisites

* NodeJS >= 8
* Yarn
* reactopya

First install [reactopya](https://github.com/flatironinstitute/reactopya):

```
pip install --upgrade reactopya
```

Now clone this repo:

```
git clone [this_repo]
cd [directory-of-the-repo]
```

**Electron development mode**

This following is the best way to develop the widgets

```
# you only need to run this once:
reactopya install-gallery-dev

# The following will open the gallery of widgets in development mode
# with hot module reloading whenever the source code changes
reactopya start-gallery-dev
```

**JupyterLab and Jupyter Notebook (development installation)**

First install the reactopya_jup Python package and JupyterLab and Jupyter Notebook extensions as above

Then from the root directory of your project:

```
reactopya install-jupyter
```

Now you should be able to `import {{ project_name }}` as in the example notebook

**Google colab**

Google colab usage is the same as JupyterLab and Jupyter Notebooks except replace `init_jupyter()` by `init_colab()`.

While it is possible to use a local runtime for colab, this involves a bit of a hack to get the callbacks to work properly. Ask me about it if you are interested.
